/* cursor.c - FCEU */
/* optim-mi-mi- zed */

#include "share.h"

static const uint8 GunSight[13*13]={
        0,0,0,0,0,0,1,0,0,0,0,0,0,
        0,0,0,0,0,0,2,0,0,0,0,0,0,
        0,0,0,0,0,0,1,0,0,0,0,0,0,
        0,0,0,0,0,0,2,0,0,0,0,0,0,
        0,0,0,0,0,0,0,0,0,0,0,0,0,
        0,0,0,0,0,0,3,0,0,0,0,0,0,
        1,2,1,2,0,3,3,3,0,2,1,2,1,
        0,0,0,0,0,0,3,0,0,0,0,0,0,
        0,0,0,0,0,0,0,0,0,0,0,0,0,
        0,0,0,0,0,0,2,0,0,0,0,0,0,
        0,0,0,0,0,0,1,0,0,0,0,0,0,
        0,0,0,0,0,0,2,0,0,0,0,0,0,
        0,0,0,0,0,0,1,0,0,0,0,0,0,
};
static const uint8 FCEUcursor[11*19]=
{
 1,0,0,0,0,0,0,0,0,0,0,
 1,1,0,0,0,0,0,0,0,0,0,
 1,2,1,0,0,0,0,0,0,0,0,
 1,2,2,1,0,0,0,0,0,0,0,
 1,2,2,2,1,0,0,0,0,0,0,
 1,2,2,2,2,1,0,0,0,0,0,
 1,2,2,2,2,2,1,0,0,0,0,
 1,2,2,2,2,2,2,1,0,0,0,
 1,2,2,2,2,2,2,2,1,0,0,
 1,2,2,2,2,2,2,2,2,1,0,
 1,2,2,2,2,2,1,1,1,1,1,
 1,2,2,1,2,2,1,0,0,0,0,
 1,2,1,0,1,2,2,1,0,0,0,
 1,1,0,0,1,2,2,1,0,0,0,
 1,0,0,0,0,1,2,2,1,0,0,
 0,0,0,0,0,1,2,2,1,0,0,
 0,0,0,0,0,0,1,2,2,1,0,
 0,0,0,0,0,0,1,2,2,1,0,
 0,0,0,0,0,0,0,1,1,0,0,
};

/* macro blitter; 2008.06.29 12:58 GMT; removed indexed mode; 2008.06.30 16:32 GMT */
#define _clippedpixloop(d,z,c,s,w,h,x,y,e)		do{ \
 const uint8 *__s=s; uint8 *__d=buf; int __c=(y)+h,__z=(x)+w; \
 if(__z>z) __z=z; if(__c>c) __c=c; /* clip bottom-right */ \
 if((__z-=(x))<=0||(__c-=(y))<=0||(x)<=-w||(y)<=-h) { /* restore, test */ \
  if((y)<0) __s-=(y)*w; else __d+=(y)*z; /* adjust left */ \
  if((x)<0) __s-=(x); else __d+=(x); /* adjust top */ \
  do{int __x=__z; uint8 *__w=__d; const uint8 *__r=__s; do{uint8 __a; \
    if((__a=*__r++)!=0) {e;}}while(++__w,--__x!=0);} \
while(__s+=w,__d+=z,--__c!=0);}}while(0)

void FCEU_DrawGunSight(uint8 *buf, int rowsize, int xc, int yc)
{
 xc-=7,yc-=7;
 _clippedpixloop(buf,rowsize,240,GunSight,13,13,xc,yc,
	if(__a==3) *__w=0xBF+-(*__w&0x3F); else *__w=--__a);
}

void FCEU_DrawCursor(uint8 *buf, int rowsize, int xc, int yc)
{
 _clippedpixloop(buf,rowsize,240,FCEUcursor,11,19,xc,yc,*__w=__a+=127);
}
